-- Author      : dannenykvist
-- Create Date : 10/16/2020 10:35:34 PM


local goobprefix = "GoobDKP"
local goobVersion = "v1.06"
--SendAddonMessage( "CTRA", "User Data: XYZ", "RAID" );


-- Create a frame
local playerName = UnitName("player");

local rankListFrame = CreateFrame("ScrollFrame", "MyMultiLineEditBox", UIParent, "InputScrollFrameTemplate")
local f = CreateFrame("Frame")
--local f2 = CreateFrame("Frame")

f:RegisterEvent("CHAT_MSG_ADDON")
--f:RegisterEvent("PLAYER_ENTERING_WORLD")
C_ChatInfo.RegisterAddonMessagePrefix(goobprefix)
f:RegisterEvent("UPDATE_MOUSEOVER_UNIT")

f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGOUT")
f:SetScript("OnEvent", OnEvent)
-- Register to monitor events

function getKeysSortedByValue(tbl, sortFunction)
  local keys = {}
  for key in pairs(tbl) do
    table.insert(keys, key)
  end

  table.sort(keys, function(a, b)
    return sortFunction(tbl[a], tbl[b])
  end)

  return keys
end

-- Handle the events as they happen
local DKPList = {}
local bMessage = ""
f:SetScript("OnEvent", function(self, event, prefix, text, channel, sender, target, zoneChannelID, localID, name, instanceID )
	--print(event)
	if event == "ADDON_LOADED" then

		if(prefix == "Goobdkp")then


		print(event, "X_" .. prefix .. "_X", text);

		if DKPDATACHARACTER == nil then
			
	

		else
			DKPList = DKPDATACHARACTER;

			printDKP()
		end

	end
end


	if event == "PLAYER_LOGOUT" then
		DKPDATACHARACTER = DKPList
	end
	if (event == "UPDATE_MOUSEOVER_UNIT") then 
		mouseoverunitname = UnitName("mouseover")
		if (mouseoverunitname ~= nil and DKPList[mouseoverunitname] ~= nil) then
			--print(mouseoverunitname)
			local bf = 1
			for i=1,GameTooltip:NumLines() do 
			local mytext=_G["GameTooltipTextLeft"..i] 
			local text=mytext:GetText()
			if (string.sub(text,0,3) == "DKP") then
				mytext:SetText("DKP: " .. DKPList[mouseoverunitname]);
				bf = 0
			end
				
			if (bf == 1) then
				GameTooltip:AddLine("DKP: " .. DKPList[mouseoverunitname])
			end
				
			GameTooltip:Show()


			end
		
		else
		GameTooltip:Show()
		end
	end
	if (event == "CHAT_MSG_ADDON") then
		if(prefix == goobprefix) then
		--print(string.sub( text, 0, 10))
		--print(string.sub( text, 0, 7))
		--print(tonumber(string.sub(goobVersion,2,8)))
		--print(tonumber(string.sub( text, 9, 15)))
		if( string.sub( text, 0, 10) == "versionv1." and tonumber(string.sub(goobVersion,2,8)) < tonumber(string.sub( text, 9, 15))) then
			print("You have old version (" .. goobVersion .. " vs " .. string.sub( text, 8, 12) .. ") of Goobdkp, download new at goobdkp.com")
		end
		
		--if( )
		--bMessage = bMessage .. text;
		for word in string.gmatch(text, '([^,]+)') do
			--print(word)
			chunks = {}
			local L = 0;
				for namedkp in string.gmatch(word, "%S+") do
					L = L + 1;
					chunks[L] = namedkp;
				end

				if (chunks[1] == playerName) then
					--GameTooltip:AddLine("DKP: " .. chunks[2])
					print("Your DKP Updated: " .. chunks[2])		
				end
				DKPList[chunks[1]] = chunks[2]
				
			--	if(playerName == chunks[2]) then
			--		
			--	end
				
		end


			local sortedKeys = getKeysSortedByValue(DKPList, function(a, b) return tonumber(a) > tonumber(b) end)
			local list = "";
			
			for _, k in pairs(sortedKeys) do

				list = list .. k .. " " .. DKPList[k] .. "\n";
			end
			rankListFrame.EditBox:SetText(list);
		end
		

		
		--local arr = split(text, " ");
		--print(arr)
		--print("You now have " .. arr[1] .. " DKP")
	end
end)

function printDKP()
			local sortedKeys = getKeysSortedByValue(DKPList, function(a, b) return tonumber(a) > tonumber(b) end)
			local list = "";
			
			for _, k in pairs(sortedKeys) do

				list = list .. k .. " " .. DKPList[k] .. "\n";
			end
			rankListFrame.EditBox:SetText(list);
end


    local someVar
    local i = 1
    --/run StaticPopup_Show("DKPDataPopup")
    StaticPopupDialogs.DKPDataPopup = {
        text = "DKPDATA",
        button1 = OKAY,
        button2 = CANCEL,
		
        OnAccept = function(self)
            someVar = self.editBox:GetText()
			someVar = string.gsub(someVar, "/adminGoobDKP 0,", "")
			--print(string.len(someVar))
			local message = ""
			C_ChatInfo.SendAddonMessage( goobprefix,  "version" .. goobVersion, "RAID")
			for word in string.gmatch(someVar, '([^,]+)') do
				
				local temp = message
				message = message .. word .. ",";
				local messagelength = string.len(message);
				if(messagelength > 254) then
				--print("message too long");
					goobDKP_wait(i, C_ChatInfo.SendAddonMessage, goobprefix, temp, "RAID")
					--print(string.len(temp))
    				i = i + 1;
					message = word .. ',';
				end
				
			end
			--print("message not too long");
			--print(string.len(message))
			goobDKP_wait(i, C_ChatInfo.SendAddonMessage, goobprefix, message, "RAID")
            --C_ChatInfo.SendAddonMessage( prefix, someVar, "RAID"  );
			--goobDKP_wait(1, C_ChatInfo.SendAddonMessage, prefix, someVar, "RAID")
        end,
        hasEditBox = 1,
		
    }
SLASH_ADMINGOOBDKP1 = "/ADMINGOOBDKP"
SlashCmdList["ADMINGOOBDKP"] = function(msg)
StaticPopup_Show("DKPDataPopup")
end
SLASH_CHECKTARGETDKP1 = "/checktargetdkp"
SlashCmdList["CHECKTARGETDKP"] = function(msg)

	local	target = GetUnitName("target");
	--print(target)
	if (target ~= nil) then
		local dkpamount = DKPList[target];

		if (dkpamount == nil) then
			print(target .. ' not updated.')
		else
			print(target .. ' has ' .. DKPList[target] .. ' DKP')
		end
	end
   --print(DKPList[GetUnitName("target")] .. ' DKP')
end 

SLASH_CHECKMYDKP1 = "/checkMyDKP"
SlashCmdList["CHECKMYDKP"] = function(msg)

	local	target = playerName
	--print(target)
	if (target ~= nil) then
		local dkpamount = DKPList[target];

		if (dkpamount == nil) then
			print('You are not updated.')
		else
			print('You have ' .. DKPList[target] .. ' DKP')
		end
	end
   --print(DKPList[GetUnitName("target")] .. ' DKP')
end 

--playerName
--GetUnitName("target")


local waitTable = {};
local waitFrame = nil;

function goobDKP_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

--local f = CreateFrame("Frame")

rankListFrame:SetSize(150,650)
rankListFrame:SetPoint("CENTER")
--rankListFrame.EditBox:SetFontObject("ChatFontNormal")
--rankListFrame.EditBox:SetMaxLetters(1024)
rankListFrame.CharCount:Hide()
local editboxParent = rankListFrame.EditBox:GetParent();
rankListFrame.EditBox:SetPoint("BOTTOMRIGHT", editboxParent, "BOTTOMRIGHT", 0, 0); -- Only this is actually needed... Change the zero's for x-offset and y-offset.
rankListFrame.EditBox:SetPoint("BOTTOMLEFT", editboxParent, "BOTTOMLEFT", 0, 0);
rankListFrame.EditBox:SetPoint("TOPRIGHT", editboxParent, "TOPRIGHT", 0, 0);
rankListFrame.EditBox:SetPoint("TOPLEFT", editboxParent, "TOPLEFT", 0, 0);

--rankListFrame.EditBox:SetAutoFocus(false);
--rankListFrame.EditBox:SetEnableMouse(false);
rankListFrame.EditBox:SetText("")
editboxParent:Hide();

SLASH_DKP1 = "/DKP"
SlashCmdList["DKP"] = function(msg)
	rankListFrame:Show();
	Frame1:Show();
end

function Button2_OnClick()
	editboxParent:Hide();
	Frame1:Hide();
	--Frame1.Hide();
end

Frame1:Hide();



